<?php

/*

Created by MakeJar https://www.makejar.com/

*/

$jarpay_name = 'Jar Pay';
$jarpay_version = '3.00';

session_start();

$settings = array();

if (is_file('includes/config.php')) {
    include 'includes/config.php';
}
include 'includes/services/expresscrypto.php';
include 'includes/services/faucethub.php';
include 'includes/services/cedsonhub.php';

$act = '';

if (isset($_POST['act'])) {
    $act = $_POST['act'];
}

if (!isset($_SESSION['jp']['message'])) {
    $_SESSION['jp']['message'] = [];
}


$currencies_fiat = ['USD', 'EUR', 'GBP', 'CAD'];

$gateways_array = [];
$currencies_crypto_array = [];
if (!empty($settings['EC_API_KEY'])) {
    $ecClass = new ExpressCryptoCurrencies();
    $gateways_array['ExpressCrypto'] = $ecClass->getCurrencies();
}
if (!empty($settings['FH_API_KEY'])) {
    $fhClass = new FaucetHubCurrencies();
    $gateways_array['FaucetHub'] = $fhClass->getCurrencies();
}
if (!empty($settings['CH_API_KEY'])) {
    $chClass = new CedsonHubCurrencies();
    $gateways_array['CedsonHub'] = $chClass->getCurrencies();
}

foreach ($gateways_array as $cryptos) {
    $currencies_crypto_array = array_unique(array_merge($currencies_crypto_array, $cryptos));
}
asort($currencies_crypto_array);

?>